#include <iostream>
#include "jatek.h"

using namespace std;

long EkkoTabla::pontszam = 0;           // sszpontszm nullzsa
short EkkoTabla::palyaId = 0;           // plyasorszm nullzsa (minden plya elejn n, mr az elsn is)

void tabla_loop(EkkoTabla* tabla){      // a jtk ismtld ciklusa
     tabla->ekkoCsere();                // koordinta bekrse
     tabla->kiszur();                   // kksorok kiszrse
     while(tabla->vanmeg()){            // ha volt mg
             tabla->kiejt();               // kkvek kiejtse
             tabla->kiir();                // tbla kirsa jbl
             tabla->kiszur();              // jbl kiszrs, htha keletkeztek j sorok
     }
}

int main(){
    const int celPontszam = 550;        // jtk clpontszma
    short tablaMeret = 10;              // kezd tblamret
    short figuraSzam = 6;               // kezd figurafajtaszm
    
    EkkoTabla *akt_tabla;                                       // aktulis tbla mutatja, j plyn cserldik
    akt_tabla = new EkkoTabla(tablaMeret,figuraSzam);           // els plya inicializlsa
    
    while(EkkoTabla::pontszam<celPontszam){                                                     // a clpontszm elrsig fut a program
             if(EkkoTabla::pontszam>(EkkoTabla::palyaId*EkkoTabla::palyaId*100)){               // kv. plyhoz palyaId^2 * 100 pont kell
                      if(!(EkkoTabla::palyaId % 3) && (EkkoTabla::palyaId<16)) --tablaMeret;    // 3.,6.,9.,12.,15. plyn cskken a tblamret
                      if(!(EkkoTabla::palyaId % 6) && (EkkoTabla::palyaId<31)) ++figuraSzam;    // 6.,12.,18.,24.,30. plyn n a figurafajtk szma
                      akt_tabla = new EkkoTabla(tablaMeret,figuraSzam);                         // j plya indtsa
             }
             tabla_loop(akt_tabla);                                                             // plyaciklus indtsa
    }
    
    akt_tabla->gyozelem();                                                                      // bcskperny ("nyertl")
    
    return 0;
}

/*
  Drgak-kiejts sablonjtk, az kkveket szimbolizl karakterekbl kell a szomszdos elemek cserjvel kirakni
  egyms mellett/alatt 3 vagy tbb darabot. A cl a program elejn meghatrozott pontszm elrse.
  
  Pontozs:
  Mindegyik plya clpontszma: [az adott plya sorszmnak ngyzete] *100 , azaz sorban 100,400,900,1600,2500,3600,...
  A kirakott kvekre kapott pontszm plynknt egyre tbb: [plya sorszma] *4 , s ha a jtkos ngyet, vagy tt hoz
  egyms mell/al (vagy ennl tbbet, de ez mr csak az j elemek vletlen beessekor jhet ki, s kicsi a valsznsge),
  akkor ez a szm minden plusz knl a msflszeresre n. Teht pl. a 3. plyn egy hrmas kiraksa 12-t r, egy ngyes
  mr 18-at, egy ts pedig 27-et.
  
  Neheztskppen az tbla mrete s a figurafajtk szma nha cskken, elbbi minden 3. plyn, egszen a 15. plyig,
  utbbi minden 6. plyn, egszen a 30. plyig.

  Amennyiben a lehetsgek elfogynnak az adott tbln, akkor a koordintkra 0,0-t megadva lehetsges j tblt krni,
  m ez a pontszmot az adott plya minimumra cskkenti.
*/
